#include <bits/stdc++.h>

using namespace std;

double najnizatackazax[100010];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int w, h, r, q, p, x,y;

    cin >> w;
    cin >> h;
    cin >> r;
    cin >> q;

    for(int i=0; i<=w; i++)
    {
        najnizatackazax[i]=h;
    }

    for(int i=0; i<q; i++)
    {
        cin >> p;

        if(p==1)
        {
            cin >> x;
            cin >> y;

            for(int j=x-r; j<=x; j++)
            {
                double yud=y-sqrt(r*r-(j-x)*(j-x));

                if(najnizatackazax[j]>yud)
                {
                    najnizatackazax[j]=yud;
                }
                if(najnizatackazax[-j+2*x]>yud)
                {
                    najnizatackazax[-j+2*x]=yud;
                }
            }
        }
        else if(p==2)
        {
            cin >> x;

            if(najnizatackazax[x]>h)
            {
                najnizatackazax[x]=h;
            }

            cout << fixed << setprecision(9) << najnizatackazax[x] << endl;
        }
    }

    return 0;
}